// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Graphic2d_PolylineMarker_HeaderFile
#define _Graphic2d_PolylineMarker_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Graphic2d_PolylineMarker_HeaderFile
#include <Handle_Graphic2d_PolylineMarker.hxx>
#endif

#ifndef _TShort_Array1OfShortReal_HeaderFile
#include <TShort_Array1OfShortReal.hxx>
#endif
#ifndef _Graphic2d_VectorialMarker_HeaderFile
#include <Graphic2d_VectorialMarker.hxx>
#endif
#ifndef _Handle_Graphic2d_GraphicObject_HeaderFile
#include <Handle_Graphic2d_GraphicObject.hxx>
#endif
#ifndef _Quantity_Length_HeaderFile
#include <Quantity_Length.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Graphic2d_Drawer_HeaderFile
#include <Handle_Graphic2d_Drawer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_ShortReal_HeaderFile
#include <Standard_ShortReal.hxx>
#endif
#ifndef _Aspect_FStream_HeaderFile
#include <Aspect_FStream.hxx>
#endif
#ifndef _Aspect_IFStream_HeaderFile
#include <Aspect_IFStream.hxx>
#endif
class Graphic2d_PolylineDefinitionError;
class Standard_OutOfRange;
class Graphic2d_GraphicObject;
class Graphic2d_Array1OfVertex;
class TColStd_Array1OfReal;
class Graphic2d_Drawer;


//! The primitive PolylineMarker <br>
//!	    Every marker takes a reference point as an argument in <br>
//!	    its constructor. CircleMarker and EllipsMarker take <br>
//!	    another point as the center and PolylineMarker takes the <br>
//!	    first point of its list as its origin. <br>
//!	    The coordinates of the centre or origin point are offsets <br>
//!	    with respect to the reference point. <br>
class Graphic2d_PolylineMarker : public Graphic2d_VectorialMarker {

public:

  //! Creates a polyline marker. <br>
//!	    The reference point is <aXPosition>, <aYPosition> <br>
//!  Warning: Raises an error if the length of the polyline <br>
//!	    is less than 2 points. <br>
  Standard_EXPORT   Graphic2d_PolylineMarker(const Handle(Graphic2d_GraphicObject)& aGraphicObject,const Quantity_Length aXPosition,const Quantity_Length aYPosition,const Graphic2d_Array1OfVertex& aListVertex);
  //! Creates a polyline marker. <br>
//!	    The reference point is <aXPosition>, <aYPosition> <br>
//!  Warning: Raises an error if the length of the polyline <br>
//!	    is less than 2 points or if length of <aListX> <br>
//!	    is not equal to length of <aListY>. <br>
  Standard_EXPORT   Graphic2d_PolylineMarker(const Handle(Graphic2d_GraphicObject)& aGraphicObject,const Quantity_Length aXPosition,const Quantity_Length aYPosition,const TColStd_Array1OfReal& aListX,const TColStd_Array1OfReal& aListY);
  //! Returns the number of points of <br>
//!          the polyline marker <br>
  Standard_EXPORT     Standard_Integer Length() const;
  //! Returns the point of rank <aRank> <br>
//!          from the polyline marker <br>
  Standard_EXPORT     void Values(const Standard_Integer aRank,Quantity_Length& X,Quantity_Length& Y) const;
  
  Standard_EXPORT   virtual  void Save(Aspect_FStream& aFStream) const;
  
  Standard_EXPORT   static  void Retrieve(Aspect_IFStream& anIFStream,const Handle(Graphic2d_GraphicObject)& aGraphicObject) ;




  DEFINE_STANDARD_RTTI(Graphic2d_PolylineMarker)

protected:

  //! Draws the polyline <me>. <br>
  Standard_EXPORT     void Draw(const Handle(Graphic2d_Drawer)& aDrawer) ;
  //! Draws edge <anIndex> of the polyline marker <me>. <br>
  Standard_EXPORT   virtual  void DrawElement(const Handle(Graphic2d_Drawer)& aDrawer,const Standard_Integer anIndex) ;
  //! Draws vertex <anIndex> of the polyline marker <me>. <br>
  Standard_EXPORT   virtual  void DrawVertex(const Handle(Graphic2d_Drawer)& aDrawer,const Standard_Integer anIndex) ;
  //! Returns Standard_True if the polyline <me> is picked, <br>
//!	    Standard_False if not. <br>
  Standard_EXPORT     Standard_Boolean Pick(const Standard_ShortReal X,const Standard_ShortReal Y,const Standard_ShortReal aPrecision,const Handle(Graphic2d_Drawer)& aDrawer) ;



private: 


TShort_Array1OfShortReal myX;
TShort_Array1OfShortReal myY;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
