// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Select2D_SensitiveBox_HeaderFile
#define _Select2D_SensitiveBox_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Select2D_SensitiveBox_HeaderFile
#include <Handle_Select2D_SensitiveBox.hxx>
#endif

#ifndef _Bnd_Box2d_HeaderFile
#include <Bnd_Box2d.hxx>
#endif
#ifndef _Select2D_TypeOfSelection_HeaderFile
#include <Select2D_TypeOfSelection.hxx>
#endif
#ifndef _Select2D_SensitiveEntity_HeaderFile
#include <Select2D_SensitiveEntity.hxx>
#endif
#ifndef _Handle_SelectBasics_EntityOwner_HeaderFile
#include <Handle_SelectBasics_EntityOwner.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class SelectBasics_EntityOwner;
class gp_Pnt2d;
class SelectBasics_ListOfBox2d;


//! defines a Sensitive Box (inside or boundary) <br>
class Select2D_SensitiveBox : public Select2D_SensitiveEntity {

public:

  //! Constructs a sensitive box object defined by the <br>
//! owner OwnerId, the center point Center, the height <br>
//! Height, the width Width, and the selection type Type. <br>
//! Type can be: <br>
//! -   interior <br>
//! -   boundary. <br>
  Standard_EXPORT   Select2D_SensitiveBox(const Handle(SelectBasics_EntityOwner)& OwnerId,const gp_Pnt2d& Center,const Standard_Real Height,const Standard_Real Width,const Select2D_TypeOfSelection Type = Select2D_TOS_INTERIOR);
  //! Constructs a sensitive box object defined by the <br>
//! owner OwnerId, the coordinates Xmin, YMin, XMax, <br>
//! YMax, and the selection type Type. <br>
//! Xmin, YMin define the minimum point in the lower left <br>
//! hand corner of the box, and   XMax, YMax define the <br>
//! maximum point in the upper right hand corner of the box. <br>
//! Type can be: <br>
//! -   interior <br>
//! -   boundary. <br>
  Standard_EXPORT   Select2D_SensitiveBox(const Handle(SelectBasics_EntityOwner)& OwnerId,const Standard_Real Xmin,const Standard_Real YMin,const Standard_Real XMax,const Standard_Real YMax,const Select2D_TypeOfSelection Type = Select2D_TOS_INTERIOR);
  
  Standard_EXPORT     void Areas(SelectBasics_ListOfBox2d& aresul) ;
  
  Standard_EXPORT     Standard_Boolean Matches(const Standard_Real X,const Standard_Real Y,const Standard_Real aTol,Standard_Real& DMin) ;
  
  Standard_EXPORT     Standard_Boolean Matches(const Standard_Real XMin,const Standard_Real YMin,const Standard_Real XMax,const Standard_Real YMax,const Standard_Real aTol) ;




  DEFINE_STANDARD_RTTI(Select2D_SensitiveBox)

protected:




private: 


Bnd_Box2d mybox;
Select2D_TypeOfSelection mytype;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
